//-------------------------------------------------------------------------
//      Declarations of SFR registers, interrupt and callt vector addresses
//      for 78K0 microcontroller uPD78F0397.
//
//      This file can be used by both the 78K0 and 78K0S assembler,
//      A78K, and the 78K0 and 78K0S C/C++ compiler, ICC78K.
//
//      This header file is generated from the device file:
//          DF0397.78K
//          Copyright (C) NEC Corporation 2005
//          Format version 2.31, File version 1.00
//
//---------------------------------------------------------------------------

#ifndef __IO78F0397_H__
#define __IO78F0397_H__

#if !defined(__A78K__) && !defined(__ICC78K__)
  #error "IO78F0397.H file for use with A78K or ICC78K V4.x only"
#endif

#if defined(__A78K__)
  #if ((__TID__ >> 4) & 0x0F) != 1
    #error "IO78F0397.H file for use with A78K option -v1 only"
  #endif
#endif
#if defined(__ICC78K__)
  #if __CORE__ != __78K0__
    #error "IO78F0397.H file for use with ICC78K option --core 78k0 only"
  #endif
#endif

#ifdef __IAR_SYSTEMS_ICC__

#pragma language=extended
#pragma system_include

//----------------------------------------------
// SFR bits (default names)
//----------------------------------------------

typedef struct
  {
    unsigned char no0:1;
    unsigned char no1:1;
    unsigned char no2:1;
    unsigned char no3:1;
    unsigned char no4:1;
    unsigned char no5:1;
    unsigned char no6:1;
    unsigned char no7:1;
  } __BITS8;

//----------------------------------------------
//       SFR declarations
//----------------------------------------------

extern __saddr __no_init volatile union { unsigned char P0; __BITS8 P0_bit; } @ 0xFF00;
extern __saddr __no_init volatile union { unsigned char P1; __BITS8 P1_bit; } @ 0xFF01;
extern __saddr __no_init volatile union { unsigned char P2; __BITS8 P2_bit; } @ 0xFF02;
extern __saddr __no_init volatile union { unsigned char P3; __BITS8 P3_bit; } @ 0xFF03;

extern __saddr __no_init volatile union { unsigned char P7; __BITS8 P7_bit; } @ 0xFF07;

extern __saddr __no_bit_access __no_init volatile const union { unsigned short ADCR; struct { unsigned char dummy; unsigned char ADCRH; }; } @ 0xFF08;
extern __saddr __no_bit_access __no_init volatile const unsigned char RXB6 @ 0xFF0A;
extern __saddr __no_bit_access __no_init volatile unsigned char TXB6 @ 0xFF0B;
extern __saddr __no_init volatile union { unsigned char P12; __BITS8 P12_bit; } @ 0xFF0C;
extern __saddr __no_init volatile union { unsigned char P13; __BITS8 P13_bit; } @ 0xFF0D;

extern __saddr __no_bit_access __no_init volatile const unsigned char SIO10 @ 0xFF0F;

extern __saddr __no_bit_access __no_init volatile unsigned short TM00 @ 0xFF10;

extern __saddr __no_bit_access __no_init volatile unsigned short CR000 @ 0xFF12;

extern __saddr __no_bit_access __no_init volatile unsigned short CR010 @ 0xFF14;
extern __saddr __no_bit_access __no_init volatile const unsigned char TM50 @ 0xFF16;
extern __saddr __no_init volatile union { unsigned char CR50; __BITS8 CR50_bit; } @ 0xFF17;
extern __saddr __no_bit_access __no_init volatile unsigned char CMP00 @ 0xFF18;
extern __saddr __no_bit_access __no_init volatile unsigned char CMP10 @ 0xFF19;
extern __saddr __no_bit_access __no_init volatile unsigned char CMP01 @ 0xFF1A;
extern __saddr __no_bit_access __no_init volatile unsigned char CMP11 @ 0xFF1B;

extern __saddr __no_bit_access __no_init volatile const unsigned char TM51 @ 0xFF1F;
extern __sfr __no_init volatile union { unsigned char PM0; __BITS8 PM0_bit; } @ 0xFF20;
extern __sfr __no_init volatile union { unsigned char PM1; __BITS8 PM1_bit; } @ 0xFF21;
extern __sfr __no_init volatile union { unsigned char PM2; __BITS8 PM2_bit; } @ 0xFF22;
extern __sfr __no_init volatile union { unsigned char PM3; __BITS8 PM3_bit; } @ 0xFF23;

extern __sfr __no_init volatile union { unsigned char PM6; __BITS8 PM6_bit; } @ 0xFF26;
extern __sfr __no_init volatile union { unsigned char PM7; __BITS8 PM7_bit; } @ 0xFF27;
extern __sfr __no_init volatile union { unsigned char ADM; __BITS8 ADM_bit; } @ 0xFF28;
extern __sfr __no_init volatile union { unsigned char ADS; __BITS8 ADS_bit; } @ 0xFF29;

extern __sfr __no_init volatile union { unsigned char PM12; __BITS8 PM12_bit; } @ 0xFF2C;

extern __sfr __no_init volatile union { unsigned char PM14; __BITS8 PM14_bit; } @ 0xFF2E;
extern __sfr __no_init volatile union { unsigned char ADPC; __BITS8 ADPC_bit; } @ 0xFF2F;
extern __sfr __no_init volatile union { unsigned char PU0; __BITS8 PU0_bit; } @ 0xFF30;
extern __sfr __no_init volatile union { unsigned char PU1; __BITS8 PU1_bit; } @ 0xFF31;

extern __sfr __no_init volatile union { unsigned char PU3; __BITS8 PU3_bit; } @ 0xFF33;

extern __sfr __no_init volatile union { unsigned char PU7; __BITS8 PU7_bit; } @ 0xFF37;

extern __sfr __no_init volatile union { unsigned char PU12; __BITS8 PU12_bit; } @ 0xFF3C;

extern __sfr __no_init volatile union { unsigned char CKS; __BITS8 CKS_bit; } @ 0xFF40;
extern __sfr __no_init volatile union { unsigned char CR51; __BITS8 CR51_bit; } @ 0xFF41;

extern __sfr __no_init volatile union { unsigned char TMC51; __BITS8 TMC51_bit; } @ 0xFF43;

extern __sfr __no_init volatile union { unsigned char EGP; __BITS8 EGP_bit; } @ 0xFF48;
extern __sfr __no_init volatile union { unsigned char EGN; __BITS8 EGN_bit; } @ 0xFF49;
extern __sfr __no_bit_access __no_init volatile const unsigned char SIO11 @ 0xFF4A;

extern __sfr __no_bit_access __no_init volatile unsigned char SOTB11 @ 0xFF4C;

extern __sfr __no_init volatile union { unsigned char ISC; __BITS8 ISC_bit; } @ 0xFF4F;
extern __sfr __no_init volatile union { unsigned char ASIM6; __BITS8 ASIM6_bit; } @ 0xFF50;

extern __sfr __no_bit_access __no_init volatile const unsigned char ASIS6 @ 0xFF53;

extern __sfr __no_bit_access __no_init volatile const unsigned char ASIF6 @ 0xFF55;
extern __sfr __no_bit_access __no_init volatile unsigned char CKSR6 @ 0xFF56;
extern __sfr __no_bit_access __no_init volatile unsigned char BRGC6 @ 0xFF57;
extern __sfr __no_init volatile union { unsigned char ASICL6; __BITS8 ASICL6_bit; } @ 0xFF58;

extern __sfr __no_bit_access __no_init volatile const union { unsigned short SDR0; struct { unsigned char SDR0L; unsigned char SDR0H; }; } @ 0xFF60;

extern __sfr __no_bit_access __no_init volatile union { unsigned short MDA0L; struct { unsigned char MDA0LL; unsigned char MDA0LH; }; } @ 0xFF62;

extern __sfr __no_bit_access __no_init volatile union { unsigned short MDA0H; struct { unsigned char MDA0HL; unsigned char MDA0HH; }; } @ 0xFF64;

extern __sfr __no_bit_access __no_init volatile union { unsigned short MDB0; struct { unsigned char MDB0L; unsigned char MDB0H; }; } @ 0xFF66;

extern __sfr __no_init volatile union { unsigned char DMUC0; __BITS8 DMUC0_bit; } @ 0xFF68;
extern __sfr __no_init volatile union { unsigned char TMHMD0; __BITS8 TMHMD0_bit; } @ 0xFF69;
extern __sfr __no_init volatile union { unsigned char TCL50; __BITS8 TCL50_bit; } @ 0xFF6A;
extern __sfr __no_init volatile union { unsigned char TMC50; __BITS8 TMC50_bit; } @ 0xFF6B;
extern __sfr __no_init volatile union { unsigned char TMHMD1; __BITS8 TMHMD1_bit; } @ 0xFF6C;
extern __sfr __no_init volatile union { unsigned char TMCYC1; __BITS8 TMCYC1_bit; } @ 0xFF6D;
extern __sfr __no_init volatile union { unsigned char KRM; __BITS8 KRM_bit; } @ 0xFF6E;
extern __sfr __no_init volatile union { unsigned char WTM; __BITS8 WTM_bit; } @ 0xFF6F;
extern __sfr __no_init volatile union { unsigned char ASIM0; __BITS8 ASIM0_bit; } @ 0xFF70;
extern __sfr __no_bit_access __no_init volatile unsigned char BRGC0 @ 0xFF71;
extern __sfr __no_bit_access __no_init volatile const unsigned char RXB0 @ 0xFF72;
extern __sfr __no_bit_access __no_init volatile const unsigned char ASIS0 @ 0xFF73;
extern __sfr __no_bit_access __no_init volatile unsigned char TXS0 @ 0xFF74;

extern __sfr __no_init volatile union { unsigned char CSIM10; __BITS8 CSIM10_bit; } @ 0xFF80;
extern __sfr __no_init volatile union { unsigned char CSIC10; __BITS8 CSIC10_bit; } @ 0xFF81;

extern __sfr __no_bit_access __no_init volatile unsigned char SOTB10 @ 0xFF84;

extern __sfr __no_init volatile union { unsigned char CSIM11; __BITS8 CSIM11_bit; } @ 0xFF88;
extern __sfr __no_init volatile union { unsigned char CSIC11; __BITS8 CSIC11_bit; } @ 0xFF89;

extern __sfr __no_init volatile union { unsigned char TCL51; __BITS8 TCL51_bit; } @ 0xFF8C;

extern __sfr __no_bit_access __no_init volatile unsigned char WDTE @ 0xFF99;

extern __sfr __no_init volatile union { unsigned char OSCCTL; __BITS8 OSCCTL_bit; } @ 0xFF9F;
extern __sfr __no_init volatile union { unsigned char RCM; __BITS8 RCM_bit; } @ 0xFFA0;
extern __sfr __no_init volatile union { unsigned char MCM; __BITS8 MCM_bit; } @ 0xFFA1;
extern __sfr __no_init volatile union { unsigned char MOC; __BITS8 MOC_bit; } @ 0xFFA2;
extern __sfr __no_init volatile const union { unsigned char OSTC; __BITS8 OSTC_bit; } @ 0xFFA3;
extern __sfr __no_init volatile union { unsigned char OSTS; __BITS8 OSTS_bit; } @ 0xFFA4;
extern __sfr __no_bit_access __no_init volatile unsigned char IIC0 @ 0xFFA5;
extern __sfr __no_init volatile union { unsigned char IICC0; __BITS8 IICC0_bit; } @ 0xFFA6;
extern __sfr __no_bit_access __no_init volatile unsigned char SVA0 @ 0xFFA7;
extern __sfr __no_init volatile union { unsigned char IICCL0; __BITS8 IICCL0_bit; } @ 0xFFA8;
extern __sfr __no_init volatile union { unsigned char IICX0; __BITS8 IICX0_bit; } @ 0xFFA9;
extern __sfr __no_init volatile const union { unsigned char IICS0; __BITS8 IICS0_bit; } @ 0xFFAA;
extern __sfr __no_init volatile union { unsigned char IICF0; __BITS8 IICF0_bit; } @ 0xFFAB;
extern __sfr __no_bit_access __no_init volatile const unsigned char RESF @ 0xFFAC;

extern __sfr __no_bit_access __no_init volatile unsigned short TM01 @ 0xFFB0;

extern __sfr __no_bit_access __no_init volatile unsigned short CR001 @ 0xFFB2;

extern __sfr __no_bit_access __no_init volatile unsigned short CR011 @ 0xFFB4;
extern __sfr __no_init volatile union { unsigned char TMC01; __BITS8 TMC01_bit; } @ 0xFFB6;
extern __sfr __no_init volatile union { unsigned char PRM01; __BITS8 PRM01_bit; } @ 0xFFB7;
extern __sfr __no_init volatile union { unsigned char CRC01; __BITS8 CRC01_bit; } @ 0xFFB8;
extern __sfr __no_init volatile union { unsigned char TOC01; __BITS8 TOC01_bit; } @ 0xFFB9;
extern __sfr __no_init volatile union { unsigned char TMC00; __BITS8 TMC00_bit; } @ 0xFFBA;
extern __sfr __no_init volatile union { unsigned char PRM00; __BITS8 PRM00_bit; } @ 0xFFBB;
extern __sfr __no_init volatile union { unsigned char CRC00; __BITS8 CRC00_bit; } @ 0xFFBC;
extern __sfr __no_init volatile union { unsigned char TOC00; __BITS8 TOC00_bit; } @ 0xFFBD;
extern __sfr __no_init volatile union { unsigned char LVIM; __BITS8 LVIM_bit; } @ 0xFFBE;
extern __sfr __no_init volatile union { unsigned char LVIS; __BITS8 LVIS_bit; } @ 0xFFBF;
extern __sfr __no_bit_access __no_init volatile unsigned char PFCMD @ 0xFFC0;

extern __sfr __no_init volatile union { unsigned char PFS; __BITS8 PFS_bit; } @ 0xFFC2;

extern __sfr __no_init volatile union { unsigned char FLPMC; __BITS8 FLPMC_bit; } @ 0xFFC4;

extern __sfr __no_init volatile union { unsigned short IF0; struct { union { unsigned char IF0L; __BITS8 IF0L_bit; }; union { unsigned char IF0H; __BITS8 IF0H_bit; }; }; } @ 0xFFE0;

extern __sfr __no_init volatile union { unsigned short IF1; struct { union { unsigned char IF1L; __BITS8 IF1L_bit; }; union { unsigned char IF1H; __BITS8 IF1H_bit; }; }; } @ 0xFFE2;

extern __sfr __no_init volatile union { unsigned short MK0; struct { union { unsigned char MK0L; __BITS8 MK0L_bit; }; union { unsigned char MK0H; __BITS8 MK0H_bit; }; }; } @ 0xFFE4;

extern __sfr __no_init volatile union { unsigned short MK1; struct { union { unsigned char MK1L; __BITS8 MK1L_bit; }; union { unsigned char MK1H; __BITS8 MK1H_bit; }; }; } @ 0xFFE6;

extern __sfr __no_init volatile union { unsigned short PR0; struct { union { unsigned char PR0L; __BITS8 PR0L_bit; }; union { unsigned char PR0H; __BITS8 PR0H_bit; }; }; } @ 0xFFE8;

extern __sfr __no_init volatile union { unsigned short PR1; struct { union { unsigned char PR1L; __BITS8 PR1L_bit; }; union { unsigned char PR1H; __BITS8 PR1H_bit; }; }; } @ 0xFFEA;

extern __sfr __no_bit_access __no_init volatile unsigned char IMS @ 0xFFF0;

extern __sfr __no_bit_access __no_init volatile unsigned char BANK @ 0xFFF3;
extern __sfr __no_bit_access __no_init volatile unsigned char IXS @ 0xFFF4;

extern __sfr __no_init volatile union { unsigned char PCC; __BITS8 PCC_bit; } @ 0xFFFB;

extern __sfr __no_bit_access __no_init volatile unsigned char R8MTRM @ 0xFFFE;

//----------------------------------------------
//       SFR bit declarations
//----------------------------------------------

#define ADCE              ADM_bit.no0
#define ADCS              ADM_bit.no7

#define CLOE              CKS_bit.no4

#define TOE51             TMC51_bit.no0
#define LVR51             TMC51_bit.no2
#define LVS51             TMC51_bit.no3
#define TCE51             TMC51_bit.no7

#define RXE6              ASIM6_bit.no5
#define TXE6              ASIM6_bit.no6
#define POWER6            ASIM6_bit.no7

#define SBRT6             ASICL6_bit.no6
#define SBRF6             ASICL6_bit.no7

#define DMUE              DMUC0_bit.no7

#define TOEN0             TMHMD0_bit.no0
#define TOLEV0            TMHMD0_bit.no1
#define TMHE0             TMHMD0_bit.no7

#define TOE50             TMC50_bit.no0
#define LVR50             TMC50_bit.no2
#define LVS50             TMC50_bit.no3
#define TCE50             TMC50_bit.no7

#define TOEN1             TMHMD1_bit.no0
#define TOLEV1            TMHMD1_bit.no1
#define TMHE1             TMHMD1_bit.no7

#define NRZ1              TMCYC1_bit.no0

#define WTM0              WTM_bit.no0
#define WTM1              WTM_bit.no1

#define RXE0              ASIM0_bit.no5
#define TXE0              ASIM0_bit.no6
#define POWER0            ASIM0_bit.no7

#define CSIE10            CSIM10_bit.no7

#define CSIE11            CSIM11_bit.no7

#define AMPH              OSCCTL_bit.no0
#define OSCSELS           OSCCTL_bit.no4
#define EXCLKS            OSCCTL_bit.no5
#define OSCSEL            OSCCTL_bit.no6
#define EXCLK             OSCCTL_bit.no7

#define RSTOP             RCM_bit.no0
#define LSRSTOP           RCM_bit.no1
#define RSTS              RCM_bit.no7

#define MCM0              MCM_bit.no0
#define MCS               MCM_bit.no1
#define XSEL              MCM_bit.no2

#define MSTOP             MOC_bit.no7

#define SPT0              IICC0_bit.no0
#define STT0              IICC0_bit.no1
#define ACKE0             IICC0_bit.no2
#define WTIM0             IICC0_bit.no3
#define SPIE0             IICC0_bit.no4
#define WREL0             IICC0_bit.no5
#define LREL0             IICC0_bit.no6
#define IICE0             IICC0_bit.no7

#define DFC0              IICCL0_bit.no2
#define SMC0              IICCL0_bit.no3
#define DAD0              IICCL0_bit.no4
#define CLD0              IICCL0_bit.no5

#define CLX0              IICX0_bit.no0

#define SPD0              IICS0_bit.no0
#define STD0              IICS0_bit.no1
#define ACKD0             IICS0_bit.no2
#define TRC0              IICS0_bit.no3
#define COI0              IICS0_bit.no4
#define EXC0              IICS0_bit.no5
#define ALD0              IICS0_bit.no6
#define MSTS0             IICS0_bit.no7

#define IICRSV            IICF0_bit.no0
#define STCEN             IICF0_bit.no1
#define IICBSY            IICF0_bit.no6
#define STCF              IICF0_bit.no7

#define OVF01             TMC01_bit.no0

#define TOE01             TOC01_bit.no0
#define LVR01             TOC01_bit.no2
#define LVS01             TOC01_bit.no3
#define OSPE01            TOC01_bit.no5
#define OSPT01            TOC01_bit.no6

#define OVF00             TMC00_bit.no0

#define TOE00             TOC00_bit.no0
#define LVR00             TOC00_bit.no2
#define LVS00             TOC00_bit.no3
#define OSPE00            TOC00_bit.no5
#define OSPT00            TOC00_bit.no6

#define LVIF              LVIM_bit.no0
#define LVIMD             LVIM_bit.no1
#define LVISEL            LVIM_bit.no2
#define LVION             LVIM_bit.no7

#define FPRERR            PFS_bit.no0

#define FLSPM0            FLPMC_bit.no0
#define FWEPR             FLPMC_bit.no2
#define FWEDIS            FLPMC_bit.no3

#define LVIIF             IF0L_bit.no0
#define PIF0              IF0L_bit.no1
#define PIF1              IF0L_bit.no2
#define PIF2              IF0L_bit.no3
#define PIF3              IF0L_bit.no4
#define PIF4              IF0L_bit.no5
#define PIF5              IF0L_bit.no6
#define SREIF6            IF0L_bit.no7

#define SRIF6             IF0H_bit.no0
#define STIF6             IF0H_bit.no1
#define CSIIF10           IF0H_bit.no2
#define DUALIF0           IF0H_bit.no2
#define STIF0             IF0H_bit.no2
#define TMIFH1            IF0H_bit.no3
#define TMIFH0            IF0H_bit.no4
#define TMIF50            IF0H_bit.no5
#define TMIF000           IF0H_bit.no6
#define TMIF010           IF0H_bit.no7

#define ADIF              IF1L_bit.no0
#define SRIF0             IF1L_bit.no1
#define WTIIF             IF1L_bit.no2
#define TMIF51            IF1L_bit.no3
#define KRIF              IF1L_bit.no4
#define WTIF              IF1L_bit.no5

#define DMUIF             IF1H_bit.no0
#define IICIF0            IF1H_bit.no0
#define CSIIF11           IF1H_bit.no1
#define TMIF001           IF1H_bit.no2
#define TMIF011           IF1H_bit.no3

#define LVIMK             MK0L_bit.no0
#define PMK0              MK0L_bit.no1
#define PMK1              MK0L_bit.no2
#define PMK2              MK0L_bit.no3
#define PMK3              MK0L_bit.no4
#define PMK4              MK0L_bit.no5
#define PMK5              MK0L_bit.no6
#define SREMK6            MK0L_bit.no7

#define SRMK6             MK0H_bit.no0
#define STMK6             MK0H_bit.no1
#define CSIMK10           MK0H_bit.no2
#define DUALMK0           MK0H_bit.no2
#define STMK0             MK0H_bit.no2
#define TMMKH1            MK0H_bit.no3
#define TMMKH0            MK0H_bit.no4
#define TMMK50            MK0H_bit.no5
#define TMMK000           MK0H_bit.no6
#define TMMK010           MK0H_bit.no7

#define ADMK              MK1L_bit.no0
#define SRMK0             MK1L_bit.no1
#define WTIMK             MK1L_bit.no2
#define TMMK51            MK1L_bit.no3
#define KRMK              MK1L_bit.no4
#define WTMK              MK1L_bit.no5

#define DMUMK             MK1H_bit.no0
#define IICMK0            MK1H_bit.no0
#define CSIMK11           MK1H_bit.no1
#define TMMK001           MK1H_bit.no2
#define TMMK011           MK1H_bit.no3

#define LVIPR             PR0L_bit.no0
#define PPR0              PR0L_bit.no1
#define PPR1              PR0L_bit.no2
#define PPR2              PR0L_bit.no3
#define PPR3              PR0L_bit.no4
#define PPR4              PR0L_bit.no5
#define PPR5              PR0L_bit.no6
#define SREPR6            PR0L_bit.no7

#define SRPR6             PR0H_bit.no0
#define STPR6             PR0H_bit.no1
#define CSIPR10           PR0H_bit.no2
#define DUALPR0           PR0H_bit.no2
#define STPR0             PR0H_bit.no2
#define TMPRH1            PR0H_bit.no3
#define TMPRH0            PR0H_bit.no4
#define TMPR50            PR0H_bit.no5
#define TMPR000           PR0H_bit.no6
#define TMPR010           PR0H_bit.no7

#define ADPR              PR1L_bit.no0
#define SRPR0             PR1L_bit.no1
#define WTIPR             PR1L_bit.no2
#define TMPR51            PR1L_bit.no3
#define KRPR              PR1L_bit.no4
#define WTPR              PR1L_bit.no5

#define DMUPR             PR1H_bit.no0
#define IICPR0            PR1H_bit.no0
#define CSIPR11           PR1H_bit.no1
#define TMPR001           PR1H_bit.no2
#define TMPR011           PR1H_bit.no3

#define CSS               PCC_bit.no4
#define CLS               PCC_bit.no5
#define XTSTART           PCC_bit.no6

#pragma language=default

#endif /* __IAR_SYSTEMS_ICC__ */

#ifdef __IAR_SYSTEMS_ASM__

//----------------------------------------------
//       SFR declarations
//----------------------------------------------

        SFRTYPE  P0         BYTE, READ, WRITE  =  0xFF00
        SFRTYPE  P1         BYTE, READ, WRITE  =  0xFF01
        SFRTYPE  P2         BYTE, READ, WRITE  =  0xFF02
        SFRTYPE  P3         BYTE, READ, WRITE  =  0xFF03

        SFRTYPE  P7         BYTE, READ, WRITE  =  0xFF07

        SFRTYPE  ADCR       WORD, READ         =  0xFF08
        SFRTYPE  ADCRH      BYTE, READ         =  0xFF09

        SFRTYPE  RXB6       BYTE, READ         =  0xFF0A
        SFRTYPE  TXB6       BYTE, READ, WRITE  =  0xFF0B
        SFRTYPE  P12        BYTE, READ, WRITE  =  0xFF0C
        SFRTYPE  P13        BYTE, READ, WRITE  =  0xFF0D

        SFRTYPE  SIO10      BYTE, READ         =  0xFF0F

        SFRTYPE  TM00       WORD, READ, WRITE  =  0xFF10

        SFRTYPE  CR000      WORD, READ, WRITE  =  0xFF12

        SFRTYPE  CR010      WORD, READ, WRITE  =  0xFF14
        SFRTYPE  TM50       BYTE, READ         =  0xFF16
        SFRTYPE  CR50       BYTE, READ, WRITE  =  0xFF17
        SFRTYPE  CMP00      BYTE, READ, WRITE  =  0xFF18
        SFRTYPE  CMP10      BYTE, READ, WRITE  =  0xFF19
        SFRTYPE  CMP01      BYTE, READ, WRITE  =  0xFF1A
        SFRTYPE  CMP11      BYTE, READ, WRITE  =  0xFF1B

        SFRTYPE  TM51       BYTE, READ         =  0xFF1F
        SFRTYPE  PM0        BYTE, READ, WRITE  =  0xFF20
        SFRTYPE  PM1        BYTE, READ, WRITE  =  0xFF21
        SFRTYPE  PM2        BYTE, READ, WRITE  =  0xFF22
        SFRTYPE  PM3        BYTE, READ, WRITE  =  0xFF23

        SFRTYPE  PM6        BYTE, READ, WRITE  =  0xFF26
        SFRTYPE  PM7        BYTE, READ, WRITE  =  0xFF27
        SFRTYPE  ADM        BYTE, READ, WRITE  =  0xFF28
        SFRTYPE  ADS        BYTE, READ, WRITE  =  0xFF29

        SFRTYPE  PM12       BYTE, READ, WRITE  =  0xFF2C

        SFRTYPE  PM14       BYTE, READ, WRITE  =  0xFF2E
        SFRTYPE  ADPC       BYTE, READ, WRITE  =  0xFF2F
        SFRTYPE  PU0        BYTE, READ, WRITE  =  0xFF30
        SFRTYPE  PU1        BYTE, READ, WRITE  =  0xFF31

        SFRTYPE  PU3        BYTE, READ, WRITE  =  0xFF33

        SFRTYPE  PU7        BYTE, READ, WRITE  =  0xFF37

        SFRTYPE  PU12       BYTE, READ, WRITE  =  0xFF3C

        SFRTYPE  CKS        BYTE, READ, WRITE  =  0xFF40
        SFRTYPE  CR51       BYTE, READ, WRITE  =  0xFF41

        SFRTYPE  TMC51      BYTE, READ, WRITE  =  0xFF43

        SFRTYPE  EGP        BYTE, READ, WRITE  =  0xFF48
        SFRTYPE  EGN        BYTE, READ, WRITE  =  0xFF49
        SFRTYPE  SIO11      BYTE, READ         =  0xFF4A

        SFRTYPE  SOTB11     BYTE, READ, WRITE  =  0xFF4C

        SFRTYPE  ISC        BYTE, READ, WRITE  =  0xFF4F
        SFRTYPE  ASIM6      BYTE, READ, WRITE  =  0xFF50

        SFRTYPE  ASIS6      BYTE, READ         =  0xFF53

        SFRTYPE  ASIF6      BYTE, READ         =  0xFF55
        SFRTYPE  CKSR6      BYTE, READ, WRITE  =  0xFF56
        SFRTYPE  BRGC6      BYTE, READ, WRITE  =  0xFF57
        SFRTYPE  ASICL6     BYTE, READ, WRITE  =  0xFF58

        SFRTYPE  SDR0       WORD, READ         =  0xFF60
        SFRTYPE  SDR0L      BYTE, READ         =  0xFF60
        SFRTYPE  SDR0H      BYTE, READ         =  0xFF61

        SFRTYPE  MDA0L      WORD, READ, WRITE  =  0xFF62
        SFRTYPE  MDA0LL     BYTE, READ, WRITE  =  0xFF62
        SFRTYPE  MDA0LH     BYTE, READ, WRITE  =  0xFF63

        SFRTYPE  MDA0H      WORD, READ, WRITE  =  0xFF64
        SFRTYPE  MDA0HL     BYTE, READ, WRITE  =  0xFF64
        SFRTYPE  MDA0HH     BYTE, READ, WRITE  =  0xFF65

        SFRTYPE  MDB0       WORD, READ, WRITE  =  0xFF66
        SFRTYPE  MDB0L      BYTE, READ, WRITE  =  0xFF66
        SFRTYPE  MDB0H      BYTE, READ, WRITE  =  0xFF67

        SFRTYPE  DMUC0      BYTE, READ, WRITE  =  0xFF68
        SFRTYPE  TMHMD0     BYTE, READ, WRITE  =  0xFF69
        SFRTYPE  TCL50      BYTE, READ, WRITE  =  0xFF6A
        SFRTYPE  TMC50      BYTE, READ, WRITE  =  0xFF6B
        SFRTYPE  TMHMD1     BYTE, READ, WRITE  =  0xFF6C
        SFRTYPE  TMCYC1     BYTE, READ, WRITE  =  0xFF6D
        SFRTYPE  KRM        BYTE, READ, WRITE  =  0xFF6E
        SFRTYPE  WTM        BYTE, READ, WRITE  =  0xFF6F
        SFRTYPE  ASIM0      BYTE, READ, WRITE  =  0xFF70
        SFRTYPE  BRGC0      BYTE, READ, WRITE  =  0xFF71
        SFRTYPE  RXB0       BYTE, READ         =  0xFF72
        SFRTYPE  ASIS0      BYTE, READ         =  0xFF73
        SFRTYPE  TXS0       BYTE, WRITE        =  0xFF74

        SFRTYPE  CSIM10     BYTE, READ, WRITE  =  0xFF80
        SFRTYPE  CSIC10     BYTE, READ, WRITE  =  0xFF81

        SFRTYPE  SOTB10     BYTE, READ, WRITE  =  0xFF84

        SFRTYPE  CSIM11     BYTE, READ, WRITE  =  0xFF88
        SFRTYPE  CSIC11     BYTE, READ, WRITE  =  0xFF89

        SFRTYPE  TCL51      BYTE, READ, WRITE  =  0xFF8C

        SFRTYPE  WDTE       BYTE, READ, WRITE  =  0xFF99

        SFRTYPE  OSCCTL     BYTE, READ, WRITE  =  0xFF9F
        SFRTYPE  RCM        BYTE, READ, WRITE  =  0xFFA0
        SFRTYPE  MCM        BYTE, READ, WRITE  =  0xFFA1
        SFRTYPE  MOC        BYTE, READ, WRITE  =  0xFFA2
        SFRTYPE  OSTC       BYTE, READ         =  0xFFA3
        SFRTYPE  OSTS       BYTE, READ, WRITE  =  0xFFA4
        SFRTYPE  IIC0       BYTE, READ, WRITE  =  0xFFA5
        SFRTYPE  IICC0      BYTE, READ, WRITE  =  0xFFA6
        SFRTYPE  SVA0       BYTE, READ, WRITE  =  0xFFA7
        SFRTYPE  IICCL0     BYTE, READ, WRITE  =  0xFFA8
        SFRTYPE  IICX0      BYTE, READ, WRITE  =  0xFFA9
        SFRTYPE  IICS0      BYTE, READ         =  0xFFAA
        SFRTYPE  IICF0      BYTE, READ, WRITE  =  0xFFAB
        SFRTYPE  RESF       BYTE, READ         =  0xFFAC

        SFRTYPE  TM01       WORD, READ, WRITE  =  0xFFB0

        SFRTYPE  CR001      WORD, READ, WRITE  =  0xFFB2

        SFRTYPE  CR011      WORD, READ, WRITE  =  0xFFB4
        SFRTYPE  TMC01      BYTE, READ, WRITE  =  0xFFB6
        SFRTYPE  PRM01      BYTE, READ, WRITE  =  0xFFB7
        SFRTYPE  CRC01      BYTE, READ, WRITE  =  0xFFB8
        SFRTYPE  TOC01      BYTE, READ, WRITE  =  0xFFB9
        SFRTYPE  TMC00      BYTE, READ, WRITE  =  0xFFBA
        SFRTYPE  PRM00      BYTE, READ, WRITE  =  0xFFBB
        SFRTYPE  CRC00      BYTE, READ, WRITE  =  0xFFBC
        SFRTYPE  TOC00      BYTE, READ, WRITE  =  0xFFBD
        SFRTYPE  LVIM       BYTE, READ, WRITE  =  0xFFBE
        SFRTYPE  LVIS       BYTE, READ, WRITE  =  0xFFBF
        SFRTYPE  PFCMD      BYTE, WRITE        =  0xFFC0

        SFRTYPE  PFS        BYTE, READ, WRITE  =  0xFFC2

        SFRTYPE  FLPMC      BYTE, READ, WRITE  =  0xFFC4

        SFRTYPE  IF0        WORD, READ, WRITE  =  0xFFE0
        SFRTYPE  IF0L       BYTE, READ, WRITE  =  0xFFE0
        SFRTYPE  IF0H       BYTE, READ, WRITE  =  0xFFE1

        SFRTYPE  IF1        WORD, READ, WRITE  =  0xFFE2
        SFRTYPE  IF1L       BYTE, READ, WRITE  =  0xFFE2
        SFRTYPE  IF1H       BYTE, READ, WRITE  =  0xFFE3

        SFRTYPE  MK0        WORD, READ, WRITE  =  0xFFE4
        SFRTYPE  MK0L       BYTE, READ, WRITE  =  0xFFE4
        SFRTYPE  MK0H       BYTE, READ, WRITE  =  0xFFE5

        SFRTYPE  MK1        WORD, READ, WRITE  =  0xFFE6
        SFRTYPE  MK1L       BYTE, READ, WRITE  =  0xFFE6
        SFRTYPE  MK1H       BYTE, READ, WRITE  =  0xFFE7

        SFRTYPE  PR0        WORD, READ, WRITE  =  0xFFE8
        SFRTYPE  PR0L       BYTE, READ, WRITE  =  0xFFE8
        SFRTYPE  PR0H       BYTE, READ, WRITE  =  0xFFE9

        SFRTYPE  PR1        WORD, READ, WRITE  =  0xFFEA
        SFRTYPE  PR1L       BYTE, READ, WRITE  =  0xFFEA
        SFRTYPE  PR1H       BYTE, READ, WRITE  =  0xFFEB

        SFRTYPE  IMS        BYTE, READ, WRITE  =  0xFFF0

        SFRTYPE  BANK       BYTE, READ, WRITE  =  0xFFF3
        SFRTYPE  IXS        BYTE, READ, WRITE  =  0xFFF4

        SFRTYPE  PCC        BYTE, READ, WRITE  =  0xFFFB

        SFRTYPE  R8MTRM     BYTE, READ, WRITE  =  0xFFFE

#endif /* __IAR_SYSTEMS_ASM__ */

//----------------------------------------------
//       Interrupt vector addresses
//----------------------------------------------

#define RST_vect                 (0x00)
#define INTCK2_vect              (0x02)
#define INTNMI_vect              (0x02)
#define INTLVI_vect              (0x04)
#define INTP0_vect               (0x06)
#define INTP1_vect               (0x08)
#define INTP2_vect               (0x0A)
#define INTP3_vect               (0x0C)
#define INTP4_vect               (0x0E)
#define INTP5_vect               (0x10)
#define INTSRE6_vect             (0x12)
#define INTSR6_vect              (0x14)
#define INTST6_vect              (0x16)
#define INTCSI10_vect            (0x18)
#define INTST0_vect              (0x18)
#define INTTMH1_vect             (0x1A)
#define INTTMH0_vect             (0x1C)
#define INTTM50_vect             (0x1E)
#define INTTM000_vect            (0x20)
#define INTTM010_vect            (0x22)
#define INTAD_vect               (0x24)
#define INTSR0_vect              (0x26)
#define INTWTI_vect              (0x28)
#define INTTM51_vect             (0x2A)
#define INTKR_vect               (0x2C)
#define INTWT_vect               (0x2E)
#define INTDMU_vect              (0x34)
#define INTIIC0_vect             (0x34)
#define INTCSI11_vect            (0x36)
#define INTTM001_vect            (0x38)
#define INTTM011_vect            (0x3A)
#define BRK_I_vect               (0x3E)

//----------------------------------------------
//       Callt vector addresses
//----------------------------------------------

#define CALLT_40_vect            (0x40)
#define CALLT_42_vect            (0x42)
#define CALLT_44_vect            (0x44)
#define CALLT_46_vect            (0x46)
#define CALLT_48_vect            (0x48)
#define CALLT_4A_vect            (0x4A)
#define CALLT_4C_vect            (0x4C)
#define CALLT_4E_vect            (0x4E)
#define CALLT_50_vect            (0x50)
#define CALLT_52_vect            (0x52)
#define CALLT_54_vect            (0x54)
#define CALLT_56_vect            (0x56)
#define CALLT_58_vect            (0x58)
#define CALLT_5A_vect            (0x5A)
#define CALLT_5C_vect            (0x5C)
#define CALLT_5E_vect            (0x5E)
#define CALLT_60_vect            (0x60)
#define CALLT_62_vect            (0x62)
#define CALLT_64_vect            (0x64)
#define CALLT_66_vect            (0x66)
#define CALLT_68_vect            (0x68)
#define CALLT_6A_vect            (0x6A)
#define CALLT_6C_vect            (0x6C)
#define CALLT_6E_vect            (0x6E)
#define CALLT_70_vect            (0x70)
#define CALLT_72_vect            (0x72)
#define CALLT_74_vect            (0x74)
#define CALLT_76_vect            (0x76)
#define CALLT_78_vect            (0x78)
#define CALLT_7A_vect            (0x7A)
#define CALLT_7C_vect            (0x7C)
#define CALLT_7E_vect            (0x7E)

#endif /* __IO78F0397_H__ */
