//==============================================================================
// PROJECT      = L_Line - L2 demo
// MODULE       = buzzer.c
// SHORT DESC.  = buzzer demonstration
// DEVICE       = 78K0/LG2
// VERSION      = 1.0
// DATE         = 01.09.2005
// LAST CHANGE  =
// =============================================================================
// By:          NEC Electronics (Europe) GmbH
//              Arcadiastrasse 10
//              D-40472 Duesseldorf
// =============================================================================

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include "io78f0397.h"
#include "lcd.h"
#include "sound.h"
#include "defines.h"

#include <intrinsics.h>

//-----------------------------------------------------------------------------
// Function prototyps
//-----------------------------------------------------------------------------
extern void Wait(unsigned char Number);

//-----------------------------------------------------------------------------
// External variables
//-----------------------------------------------------------------------------
extern __saddr volatile unsigned char sw3_in;

//-----------------------------------------------------------------------------
// Global constants
//-----------------------------------------------------------------------------
extern const char *s_song;

//-----------------------------------------------------------------------------
// Module:   play
// Function: plays melody
//-----------------------------------------------------------------------------
void play(unsigned int const *point)
{
    while(*point!=END)
    {
              TMC01 = 0x00;       // stop Timer01
              TOC01 = 0x09;       // timer output set
              if(*point)
              {
                CRC01 = 0x00;       // CR011 and CR001 operating as compare register
                CR001 = *point;
                CR011 = *point>>2;
                TOC01 = 0x1B;       // successive pulse output mode, enable inversion
                PRM01 = 0x01;
                TMC01 = 0x0c;       // start Timer01 in free-running mode
              }
              *point++;
              Wait(*point);
              *point++;
              if(sw3_in==LEFT) return;
    }
}

//-----------------------------------------------------------------------------
// Module:   buzzer
// Function: buzzer demonstration
//-----------------------------------------------------------------------------
void buzzer()
{
   PM0_bit.no6=0;      // output mode
   LCD_string(&s_song[0],0);
   while(sw3_in!=LEFT)
   {
      play(&song[0]);
   }
   sw3_in=0;
   TMC01 = 0x00;       // stop Timer01
   TOC01 = 0x09;       // timer output set
}

