//==============================================================================
// PROJECT      = L_Line - L2 demo
// MODULE       = light.c
// SHORT DESC.  = demostration for photo transistor
// DEVICE       = 78K0/LG2
// VERSION      = 1.0
// DATE         = 01.09.2005
// LAST CHANGE  =
// =============================================================================
// By:          NEC Electronics (Europe) GmbH
//              Arcadiastrasse 10
//              D-40472 Duesseldorf
// =============================================================================

//-----------------------------------------------------------------------------
// Include files
//-----------------------------------------------------------------------------
#include "io78f0397.h"
#include "lcd.h"
#include "defines.h"
#include <intrinsics.h>

//-----------------------------------------------------------------------------
// Function prototyps
//-----------------------------------------------------------------------------
extern void Wait(unsigned char Number);
extern __callt void  BCD_calc(unsigned char data);

//-----------------------------------------------------------------------------
// variables
//-----------------------------------------------------------------------------
__saddr char adc_result;

//-----------------------------------------------------------------------------
// External variables
//-----------------------------------------------------------------------------
extern __saddr volatile unsigned char sw3_in;


extern struct    {unsigned char s100;
                  unsigned char s10;
                  unsigned char s1;}bcd;


//-----------------------------------------------------------------------------
// Module:   light
// Function: measurement of light level
//-----------------------------------------------------------------------------
void light()
{
  // initialization of ADC	
  ADM  = 0x10;                        //set conversion time to 192/fx = 24us
  ADS  = 0x00;                        //select AD channel
  ADCE = 1;                           //enable voltage generator
  ADCS = 1;                           //start AD converter

  while(sw3_in!=LEFT)
  {
    while(!ADIF);
    ADIF=0;
    adc_result = ADCRH;               //load 8-bit AD conversion result
    adc_result = 100 - (adc_result * 100 / 255);
    BCD_calc(adc_result);
    LCD_putc (1, bcd.s100);
    LCD_putc (2, bcd.s10);
    LCD_putc (3, bcd.s1);
    LCD_string("/o",5);
    Wait(4);
  }
  ADCS = 0;                           //stop AD converter
  sw3_in=0;
}


